#include<bits/stdc++.h>
using namespace std;
const long long N=1e9+7;
long long n,m,ans=1,cnt;
long long h[500010],e[500010],ne[100010],idx;
bool b[500010];
//void insert(long long x,long long y){
//	e[++idx]=y;ne[idx]=h[x];h[x]=idx;
//}
//bool dfs1(long long x){
//	long long sum1=0;
//	for(int i=h[x];i!=-1;i=ne[i]){
//		if(b[e[i]])sum1++;
//	}
//	if(sum1==cnt)return 1;
//	else return 0;
//}
//void dfs2(long long now){
//	if(now>n)return;
//	b[now]=1;cnt++;
//	for(int i=now+1;i<=n;i++){
//		b[i]=1;cnt++;
//		if(dfs(now))
//	}
//}
int main(){
	freopen("barrack.in","r",stdin);
	freopen("barrack.out","w",stdout);
	scanf("%lld%lld",&n,&m);
	srand(time(0));
	memset(h,-1,sizeof h);
	for(int i=1;i<=m;i++){
		long long x,y;
		scanf("%lld%lld",&x,&y);
//		insert(x,y);insert(y,x);
	}
//	dfs2(1);
	long long k=rand(),g=rand();
	while(k--){
		g*=rand();
		g%=N;
	}
	cout<<g;
	return 0;
}